
<!DOCTYPE html>


<html lang="en" data-content_root="../../../" >

  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" /><meta name="viewport" content="width=device-width, initial-scale=1" />

    <title>Recipes &#8212; Eclipse Aidge  documentation</title>
  
  
  
  <script data-cfasync="false">
    document.documentElement.dataset.mode = localStorage.getItem("mode") || "";
    document.documentElement.dataset.theme = localStorage.getItem("theme") || "";
  </script>
  <!--
    this give us a css class that will be invisible only if js is disabled
  -->
  <noscript>
    <style>
      .pst-js-only { display: none !important; }

    </style>
  </noscript>
  
  <!-- Loaded before other Sphinx assets -->
  <link href="../../../_static/styles/theme.css?digest=8878045cc6db502f8baf" rel="stylesheet" />
<link href="../../../_static/styles/pydata-sphinx-theme.css?digest=8878045cc6db502f8baf" rel="stylesheet" />

    <link rel="stylesheet" type="text/css" href="../../../_static/pygments.css?v=8f2a1f02" />
    <link rel="stylesheet" type="text/css" href="../../../_static/graphviz.css?v=4ae1632d" />
    <link rel="stylesheet" type="text/css" href="../../../_static/copybutton.css?v=76b2166b" />
    <link rel="stylesheet" type="text/css" href="../../../_static/sg_gallery.css?v=d2d258e8" />
    <link rel="stylesheet" type="text/css" href="../../../_static/sphinx-design.min.css?v=95c83b7e" />
    <link rel="stylesheet" type="text/css" href="../../../_static/css/custom.css?v=794b2ffd" />
  
  <!-- So that users can add custom icons -->
  <script src="../../../_static/scripts/fontawesome.js?digest=8878045cc6db502f8baf"></script>
  <!-- Pre-loaded scripts that we'll load fully later -->
  <link rel="preload" as="script" href="../../../_static/scripts/bootstrap.js?digest=8878045cc6db502f8baf" />
<link rel="preload" as="script" href="../../../_static/scripts/pydata-sphinx-theme.js?digest=8878045cc6db502f8baf" />

    <script src="../../../_static/documentation_options.js?v=5929fcd5"></script>
    <script src="../../../_static/doctools.js?v=9bcbadda"></script>
    <script src="../../../_static/sphinx_highlight.js?v=dc90522c"></script>
    <script src="../../../_static/clipboard.min.js?v=a7894cd8"></script>
    <script src="../../../_static/copybutton.js?v=f281be69"></script>
    <script src="../../../_static/design-tabs.js?v=f930bc37"></script>
    <script src="https://cdn.jsdelivr.net/npm/@jupyter-widgets/html-manager@^1.0.1/dist/embed-amd.js"></script>
    <script>DOCUMENTATION_OPTIONS.pagename = 'source/API/Core/recipes';</script>
    <script>
        DOCUMENTATION_OPTIONS.theme_version = '0.16.1';
        DOCUMENTATION_OPTIONS.theme_switcher_json_url = 'https://eclipse-aidge.readthedocs.io/en/dev/_static/version_switcher.json';
        DOCUMENTATION_OPTIONS.theme_switcher_version_match = '0.5.0';
        DOCUMENTATION_OPTIONS.show_version_warning_banner =
            false;
        </script>
    <script src="../../../_static/js/mermaid.min.js"></script>
    <link rel="index" title="Index" href="../../../genindex.html" />
    <link rel="search" title="Search" href="../../../search.html" />
    <link rel="next" title="Export" href="export.html" />
    <link rel="prev" title="Graph Matching" href="graphMatching.html" />
  <meta name="viewport" content="width=device-width, initial-scale=1"/>
  <meta name="docsearch:language" content="en"/>
  <meta name="docsearch:version" content="0.5.0" />
  </head>
  
  
  <body data-bs-spy="scroll" data-bs-target=".bd-toc-nav" data-offset="180" data-bs-root-margin="0px 0px -60%" data-default-mode="">

  
  
  <div id="pst-skip-link" class="skip-link d-print-none"><a href="#main-content">Skip to main content</a></div>
  
  <div id="pst-scroll-pixel-helper"></div>
  
  <button type="button" class="btn rounded-pill" id="pst-back-to-top">
    <i class="fa-solid fa-arrow-up"></i>Back to top</button>

  
  <dialog id="pst-search-dialog">
    
<form class="bd-search d-flex align-items-center"
      action="../../../search.html"
      method="get">
  <i class="fa-solid fa-magnifying-glass"></i>
  <input type="search"
         class="form-control"
         name="q"
         placeholder="Search the docs ..."
         aria-label="Search the docs ..."
         autocomplete="off"
         autocorrect="off"
         autocapitalize="off"
         spellcheck="false"/>
  <span class="search-button__kbd-shortcut"><kbd class="kbd-shortcut__modifier">Ctrl</kbd>+<kbd>K</kbd></span>
</form>
  </dialog>

  <div class="pst-async-banner-revealer d-none">
  <aside id="bd-header-version-warning" class="d-none d-print-none" aria-label="Version warning"></aside>
</div>

  
    <header class="bd-header navbar navbar-expand-lg bd-navbar d-print-none">
<div class="bd-header__inner bd-page-width">
  <button class="pst-navbar-icon sidebar-toggle primary-toggle" aria-label="Site navigation">
    <span class="fa-solid fa-bars"></span>
  </button>
  
  
  <div class="col-lg-3 navbar-header-items__start">
    
      <div class="navbar-item">

  
    
  

<a class="navbar-brand logo" href="../../../index.html">
  
  
  
  
  
    
    
      
    
    
    <img src="../../../_static/Isotype-aidge.png" class="logo__image only-light" alt=""/>
    <img src="../../../_static/Isotype-aidge.png" class="logo__image only-dark pst-js-only" alt=""/>
  
  
    <p class="title logo__title">Eclipse Aidge</p>
  
</a></div>
    
      <div class="navbar-item">
<div class="version-switcher__container dropdown pst-js-only">
  <button id="pst-version-switcher-button-2"
    type="button"
    class="version-switcher__button btn btn-sm dropdown-toggle"
    data-bs-toggle="dropdown"
    aria-haspopup="listbox"
    aria-controls="pst-version-switcher-list-2"
    aria-label="Version switcher list"
  >
    Choose version  <!-- this text may get changed later by javascript -->
    <span class="caret"></span>
  </button>
  <div id="pst-version-switcher-list-2"
    class="version-switcher__menu dropdown-menu list-group-flush py-0"
    role="listbox" aria-labelledby="pst-version-switcher-button-2">
    <!-- dropdown will be populated by javascript on page load -->
  </div>
</div></div>
    
  </div>
  
  <div class="col-lg-9 navbar-header-items">
    
    <div class="me-auto navbar-header-items__center">
      
        <div class="navbar-item">
<nav>
  <ul class="bd-navbar-elements navbar-nav">
    
<li class="nav-item ">
  <a class="nav-link nav-internal" href="../../GetStarted/index.html">
    Get Started
  </a>
</li>


<li class="nav-item ">
  <a class="nav-link nav-internal" href="../../UserGuide/index.html">
    User Guide
  </a>
</li>


<li class="nav-item ">
  <a class="nav-link nav-internal" href="../../Tutorial/index.html">
    Tutorials
  </a>
</li>


<li class="nav-item current active">
  <a class="nav-link nav-internal" href="../index.html">
    API
  </a>
</li>

  </ul>
</nav></div>
      
    </div>
    
    
    <div class="navbar-header-items__end">
      
        <div class="navbar-item navbar-persistent--container">
          

<button class="btn search-button-field search-button__button pst-js-only" title="Search" aria-label="Search" data-bs-placement="bottom" data-bs-toggle="tooltip">
 <i class="fa-solid fa-magnifying-glass"></i>
 <span class="search-button__default-text">Search</span>
 <span class="search-button__kbd-shortcut"><kbd class="kbd-shortcut__modifier">Ctrl</kbd>+<kbd class="kbd-shortcut__modifier">K</kbd></span>
</button>
        </div>
      
      
        <div class="navbar-item">

<button class="btn btn-sm nav-link pst-navbar-icon theme-switch-button pst-js-only" aria-label="Color mode" data-bs-title="Color mode"  data-bs-placement="bottom" data-bs-toggle="tooltip">
  <i class="theme-switch fa-solid fa-sun                fa-lg" data-mode="light" title="Light"></i>
  <i class="theme-switch fa-solid fa-moon               fa-lg" data-mode="dark"  title="Dark"></i>
  <i class="theme-switch fa-solid fa-circle-half-stroke fa-lg" data-mode="auto"  title="System Settings"></i>
</button></div>
      
        <div class="navbar-item"><ul class="navbar-icon-links"
    aria-label="Icon Links">
        <li class="nav-item">
          
          
          
          
          
          
          
          
          <a href="<https://gitlab.eclipse.org/eclipse/aidge>" title="GitLab" class="nav-link pst-navbar-icon" rel="noopener" target="_blank" data-bs-toggle="tooltip" data-bs-placement="bottom"><i class="fab fa-gitlab fa-lg" aria-hidden="true"></i>
            <span class="sr-only">GitLab</span></a>
        </li>
</ul></div>
      
    </div>
    
  </div>
  
  
    <div class="navbar-persistent--mobile">

<button class="btn search-button-field search-button__button pst-js-only" title="Search" aria-label="Search" data-bs-placement="bottom" data-bs-toggle="tooltip">
 <i class="fa-solid fa-magnifying-glass"></i>
 <span class="search-button__default-text">Search</span>
 <span class="search-button__kbd-shortcut"><kbd class="kbd-shortcut__modifier">Ctrl</kbd>+<kbd class="kbd-shortcut__modifier">K</kbd></span>
</button>
    </div>
  

  
    <button class="pst-navbar-icon sidebar-toggle secondary-toggle" aria-label="On this page">
      <span class="fa-solid fa-outdent"></span>
    </button>
  
</div>

    </header>
  

  <div class="bd-container">
    <div class="bd-container__inner bd-page-width">
      
      
      
      <dialog id="pst-primary-sidebar-modal"></dialog>
      <div id="pst-primary-sidebar" class="bd-sidebar-primary bd-sidebar">
        

  
  <div class="sidebar-header-items sidebar-primary__section">
    
    
      <div class="sidebar-header-items__center">
        
          
          
            <div class="navbar-item">
<nav>
  <ul class="bd-navbar-elements navbar-nav">
    
<li class="nav-item ">
  <a class="nav-link nav-internal" href="../../GetStarted/index.html">
    Get Started
  </a>
</li>


<li class="nav-item ">
  <a class="nav-link nav-internal" href="../../UserGuide/index.html">
    User Guide
  </a>
</li>


<li class="nav-item ">
  <a class="nav-link nav-internal" href="../../Tutorial/index.html">
    Tutorials
  </a>
</li>


<li class="nav-item current active">
  <a class="nav-link nav-internal" href="../index.html">
    API
  </a>
</li>

  </ul>
</nav></div>
          
        
      </div>
    
    
    
      <div class="sidebar-header-items__end">
        
          <div class="navbar-item">

<button class="btn btn-sm nav-link pst-navbar-icon theme-switch-button pst-js-only" aria-label="Color mode" data-bs-title="Color mode"  data-bs-placement="bottom" data-bs-toggle="tooltip">
  <i class="theme-switch fa-solid fa-sun                fa-lg" data-mode="light" title="Light"></i>
  <i class="theme-switch fa-solid fa-moon               fa-lg" data-mode="dark"  title="Dark"></i>
  <i class="theme-switch fa-solid fa-circle-half-stroke fa-lg" data-mode="auto"  title="System Settings"></i>
</button></div>
        
          <div class="navbar-item"><ul class="navbar-icon-links"
    aria-label="Icon Links">
        <li class="nav-item">
          
          
          
          
          
          
          
          
          <a href="<https://gitlab.eclipse.org/eclipse/aidge>" title="GitLab" class="nav-link pst-navbar-icon" rel="noopener" target="_blank" data-bs-toggle="tooltip" data-bs-placement="bottom"><i class="fab fa-gitlab fa-lg" aria-hidden="true"></i>
            <span class="sr-only">GitLab</span></a>
        </li>
</ul></div>
        
      </div>
    
  </div>
  
    <div class="sidebar-primary-items__start sidebar-primary__section">
        <div class="sidebar-primary-item">
<nav class="bd-docs-nav bd-links"
     aria-label="Section Navigation">
  <p class="bd-links__title" role="heading" aria-level="1">Section Navigation</p>
  <div class="bd-toc-item navbar-nav"><ul class="current nav bd-sidenav">
<li class="toctree-l1 current active has-children"><a class="reference internal" href="index.html">Aidge core API</a><details open="open"><summary><span class="toctree-toggle" role="presentation"><i class="fa-solid fa-chevron-down"></i></span></summary><ul class="current">
<li class="toctree-l2"><a class="reference internal" href="data.html">Data</a></li>
<li class="toctree-l2"><a class="reference internal" href="graph.html">Graph</a></li>
<li class="toctree-l2"><a class="reference internal" href="operator.html">Operators</a></li>
<li class="toctree-l2"><a class="reference internal" href="backend.html">Backend</a></li>
<li class="toctree-l2"><a class="reference internal" href="scheduler.html">Scheduler</a></li>
<li class="toctree-l2"><a class="reference internal" href="graphMatching.html">Graph Matching</a></li>
<li class="toctree-l2 current active"><a class="current reference internal" href="#">Recipes</a></li>
<li class="toctree-l2"><a class="reference internal" href="export.html">Export</a></li>
</ul>
</details></li>
<li class="toctree-l1"><a class="reference internal" href="../BackendCPU/index.html">Aidge backend CPU</a></li>
<li class="toctree-l1"><a class="reference internal" href="../Onnx/index.html">Aidge ONNX API</a></li>
<li class="toctree-l1"><a class="reference internal" href="../BackendOPENCV/index.html">Aidge backend OpenCV API</a></li>
<li class="toctree-l1"><a class="reference internal" href="../ExportTensorRT/index.html">Aidge Export TensorRT API</a></li>
</ul>
</div>
</nav></div>
    </div>
  
  
  <div class="sidebar-primary-items__end sidebar-primary__section">
      <div class="sidebar-primary-item">
<div id="ethical-ad-placement"
      class="flat"
      data-ea-publisher="readthedocs"
      data-ea-type="readthedocs-sidebar"
      data-ea-manual="true">
</div></div>
  </div>


      </div>
      
      <main id="main-content" class="bd-main" role="main">
        
        
          <div class="bd-content">
            <div class="bd-article-container">
              
              <div class="bd-header-article d-print-none">
<div class="header-article-items header-article__inner">
  
    <div class="header-article-items__start">
      
        <div class="header-article-item">

<nav aria-label="Breadcrumb" class="d-print-none">
  <ul class="bd-breadcrumbs">
    
    <li class="breadcrumb-item breadcrumb-home">
      <a href="../../../index.html" class="nav-link" aria-label="Home">
        <i class="fa-solid fa-home"></i>
      </a>
    </li>
    
    <li class="breadcrumb-item"><a href="../index.html" class="nav-link">API</a></li>
    
    
    <li class="breadcrumb-item"><a href="index.html" class="nav-link">Aidge core API</a></li>
    
    <li class="breadcrumb-item active" aria-current="page"><span class="ellipsis">Recipes</span></li>
  </ul>
</nav>
</div>
      
    </div>
  
  
</div>
</div>
              
              
              
                
<div id="searchbox"></div>
                <article class="bd-article">
                  
  <section id="recipes">
<h1>Recipes<a class="headerlink" href="#recipes" title="Link to this heading">#</a></h1>
<p>Recipes are relatively generic, built-in functionnalities for manipulating a compute graph in Aidge. Some are built with Aidge’s graph matching engine, do not hesitate to have a look at their source code to understand how they work and build similar functionnalities!</p>
<nav class="contents local" id="contents">
<ul class="simple">
<li><p><a class="reference internal" href="#adapt-to-backend" id="id137">Adapt to backend</a></p></li>
<li><p><a class="reference internal" href="#constant-folding" id="id138">Constant folding</a></p></li>
<li><p><a class="reference internal" href="#convert-conv-to-matmul" id="id139">Convert Conv to MatMul</a></p></li>
<li><p><a class="reference internal" href="#expand-meta-operators" id="id140">Expand meta operators</a></p></li>
<li><p><a class="reference internal" href="#explicit-cast-move" id="id141">Explicit Cast Move</a></p></li>
<li><p><a class="reference internal" href="#explicit-transpose" id="id142">Explicit Transpose</a></p></li>
<li><p><a class="reference internal" href="#fuse-batchnorm" id="id143">Fuse BatchNorm</a></p></li>
<li><p><a class="reference internal" href="#fuse-matmul-and-add-to-fc" id="id144">Fuse MatMul and Add to FC</a></p></li>
<li><p><a class="reference internal" href="#fuse-to-meta-operator" id="id145">Fuse to meta operator</a></p></li>
<li><p><a class="reference internal" href="#matmul-tiling" id="id146">MatMul tiling</a></p></li>
<li><p><a class="reference internal" href="#remove-dropout" id="id147">Remove Dropout</a></p></li>
<li><p><a class="reference internal" href="#remove-flatten" id="id148">Remove Flatten</a></p></li>
</ul>
</nav>
<p>🚧 The list of recipes is still growing!</p>
<section id="adapt-to-backend">
<h2><a class="toc-backref" href="#id137" role="doc-backlink">Adapt to backend</a><a class="headerlink" href="#adapt-to-backend" title="Link to this heading">#</a></h2>
<p>Adapt a graph to the available kernels of a backend. The following transformations
can be performed at the inputs and/or the outputs of operators:
- <code class="docutils literal notranslate"><span class="pre">Cast</span></code>: change of data type;
- <code class="docutils literal notranslate"><span class="pre">Transpose</span></code>: change of data format.</p>
<div class="sd-tab-set docutils">
<input checked="checked" id="sd-tab-item-0" name="sd-tab-set-0" type="radio">
<label class="sd-tab-label" for="sd-tab-item-0">
Python</label><div class="sd-tab-content docutils">
<dl class="py function">
<dt class="sig sig-object py" id="aidge_core.adapt_to_backend">
<span class="sig-prename descclassname"><span class="pre">aidge_core.</span></span><span class="sig-name descname"><span class="pre">adapt_to_backend</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">graph_view</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><a class="reference internal" href="graph.html#aidge_core.GraphView" title="aidge_core.aidge_core.GraphView"><span class="pre">aidge_core.aidge_core.GraphView</span></a></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">None</span></span></span><a class="headerlink" href="#aidge_core.adapt_to_backend" title="Link to this definition">#</a></dt>
<dd><p>Adapt the graph to a specific backend.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters<span class="colon">:</span></dt>
<dd class="field-odd"><p><strong>graph_view</strong> (<a class="reference internal" href="graph.html#aidge_core.GraphView" title="aidge_core.GraphView"><code class="xref py py-class docutils literal notranslate"><span class="pre">aidge_core.GraphView</span></code></a>) – Graph view on which we want to apply the recipe</p>
</dd>
</dl>
</dd></dl>

</div>
<input id="sd-tab-item-1" name="sd-tab-set-0" type="radio">
<label class="sd-tab-label" for="sd-tab-item-1">
C++</label><div class="sd-tab-content docutils">
<dl class="cpp function">
<dt class="sig sig-object cpp" id="_CPPv4N5Aidge14adaptToBackendENSt10shared_ptrI9GraphViewEE">
<span class="target" id="Recipes_8hpp_1ad4a548fbd1479fbd2b5810165cb3a303"></span><span class="kt"><span class="pre">void</span></span><span class="w"> </span><span class="sig-prename descclassname"><span class="n"><span class="pre">Aidge</span></span><span class="p"><span class="pre">::</span></span></span><span class="sig-name descname"><span class="n"><span class="pre">adaptToBackend</span></span></span><span class="sig-paren">(</span><span class="n"><span class="pre">std</span></span><span class="p"><span class="pre">::</span></span><span class="n"><span class="pre">shared_ptr</span></span><span class="p"><span class="pre">&lt;</span></span><a class="reference internal" href="graph.html#_CPPv4N5Aidge9GraphViewE" title="Aidge::GraphView"><span class="n"><span class="pre">GraphView</span></span></a><span class="p"><span class="pre">&gt;</span></span><span class="w"> </span><span class="n sig-param"><span class="pre">graph</span></span><span class="sig-paren">)</span><a class="headerlink" href="#_CPPv4N5Aidge14adaptToBackendENSt10shared_ptrI9GraphViewEE" title="Link to this definition">#</a><br /></dt>
<dd><p>Adapt a graph to the available kernels of a backend. </p>
<dl class="field-list simple">
<dt class="field-odd">Parameters<span class="colon">:</span></dt>
<dd class="field-odd"><p><strong>graph</strong> – Graph to manipulate </p>
</dd>
</dl>
</dd></dl>

</div>
</div>
</section>
<section id="constant-folding">
<h2><a class="toc-backref" href="#id138" role="doc-backlink">Constant folding</a><a class="headerlink" href="#constant-folding" title="Link to this heading">#</a></h2>
<p>Fold constant operators (like ONNX Simplifier).</p>
<div class="sd-tab-set docutils">
<input checked="checked" id="sd-tab-item-2" name="sd-tab-set-1" type="radio">
<label class="sd-tab-label" for="sd-tab-item-2">
C++</label><div class="sd-tab-content docutils">
<dl class="cpp function">
<dt class="sig sig-object cpp" id="_CPPv4N5Aidge15constantFoldingENSt10shared_ptrI9GraphViewEE">
<span class="target" id="Recipes_8hpp_1af3e7618f6067ca815e9771198220d099"></span><span class="kt"><span class="pre">void</span></span><span class="w"> </span><span class="sig-prename descclassname"><span class="n"><span class="pre">Aidge</span></span><span class="p"><span class="pre">::</span></span></span><span class="sig-name descname"><span class="n"><span class="pre">constantFolding</span></span></span><span class="sig-paren">(</span><span class="n"><span class="pre">std</span></span><span class="p"><span class="pre">::</span></span><span class="n"><span class="pre">shared_ptr</span></span><span class="p"><span class="pre">&lt;</span></span><a class="reference internal" href="graph.html#_CPPv4N5Aidge9GraphViewE" title="Aidge::GraphView"><span class="n"><span class="pre">GraphView</span></span></a><span class="p"><span class="pre">&gt;</span></span><span class="w"> </span><span class="n sig-param"><span class="pre">graph</span></span><span class="sig-paren">)</span><a class="headerlink" href="#_CPPv4N5Aidge15constantFoldingENSt10shared_ptrI9GraphViewEE" title="Link to this definition">#</a><br /></dt>
<dd></dd></dl>

</div>
</div>
</section>
<section id="convert-conv-to-matmul">
<h2><a class="toc-backref" href="#id139" role="doc-backlink">Convert Conv to MatMul</a><a class="headerlink" href="#convert-conv-to-matmul" title="Link to this heading">#</a></h2>
<p>Convert <code class="docutils literal notranslate"><span class="pre">Conv</span></code> operators to <code class="docutils literal notranslate"><span class="pre">Unfold</span></code> (im2col operation) + <code class="docutils literal notranslate"><span class="pre">MatMul</span></code> + <code class="docutils literal notranslate"><span class="pre">Reshape</span></code>.</p>
<div class="sd-tab-set docutils">
<input checked="checked" id="sd-tab-item-3" name="sd-tab-set-2" type="radio">
<label class="sd-tab-label" for="sd-tab-item-3">
C++</label><div class="sd-tab-content docutils">
<dl class="cpp function">
<dt class="sig sig-object cpp">
<span class="target" id="Recipes_8hpp_1af3e7618f6067ca815e9771198220d099"></span><span class="kt"><span class="pre">void</span></span><span class="w"> </span><span class="sig-prename descclassname"><span class="n"><span class="pre">Aidge</span></span><span class="p"><span class="pre">::</span></span></span><span class="sig-name descname"><span class="n"><span class="pre">constantFolding</span></span></span><span class="sig-paren">(</span><span class="n"><span class="pre">std</span></span><span class="p"><span class="pre">::</span></span><span class="n"><span class="pre">shared_ptr</span></span><span class="p"><span class="pre">&lt;</span></span><a class="reference internal" href="graph.html#_CPPv4N5Aidge9GraphViewE" title="Aidge::GraphView"><span class="n"><span class="pre">GraphView</span></span></a><span class="p"><span class="pre">&gt;</span></span><span class="w"> </span><span class="n sig-param"><span class="pre">graph</span></span><span class="sig-paren">)</span><br /></dt>
<dd></dd></dl>

</div>
</div>
<p>Input graph:</p>
<p><a href="#id1"><span class="problematic" id="id2">``</span></a><a href="#id3"><span class="problematic" id="id4">`</span></a>mermaid
%%{init: {‘flowchart’: { ‘curve’: ‘monotoneY’}, ‘fontFamily’: ‘Verdana’ } }%%
flowchart TB</p>
<p>Producer_3(“conv2_wn&lt;sub&gt;&lt;em&gt;(Producer#3)&lt;/em&gt;&lt;/sub&gt;”):::producerCls
Conv_1(“conv2n&lt;sub&gt;&lt;em&gt;(Conv#1)&lt;/em&gt;&lt;/sub&gt;”)
Conv_0(“conv1n&lt;sub&gt;&lt;em&gt;(Conv#0)&lt;/em&gt;&lt;/sub&gt;”)
Producer_2(“conv1_bn&lt;sub&gt;&lt;em&gt;(Producer#2)&lt;/em&gt;&lt;/sub&gt;”):::producerCls
Producer_1(“conv1_wn&lt;sub&gt;&lt;em&gt;(Producer#1)&lt;/em&gt;&lt;/sub&gt;”):::producerCls
Producer_4(“conv3_wn&lt;sub&gt;&lt;em&gt;(Producer#4)&lt;/em&gt;&lt;/sub&gt;”):::producerCls
Conv_2(“conv3n&lt;sub&gt;&lt;em&gt;(Conv#2)&lt;/em&gt;&lt;/sub&gt;”)
Producer_5(“conv3_bn&lt;sub&gt;&lt;em&gt;(Producer#5)&lt;/em&gt;&lt;/sub&gt;”):::producerCls
Producer_0(“dataProvidern&lt;sub&gt;&lt;em&gt;(Producer#0)&lt;/em&gt;&lt;/sub&gt;”):::producerCls_rootCls
Producer_3–&gt;|”0 [7, 4, 3, 3]&amp;rarr;1”<a href="#id41"><span class="problematic" id="id42">|Conv_1
Conv_1--&gt;|</span></a>”0 [2, 7, 9, 20]&amp;rarr;0”<a href="#id43"><span class="problematic" id="id44">|Conv_2
Conv_0--&gt;|</span></a>”0 [2, 4, 11, 22]&amp;rarr;0”<a href="#id45"><span class="problematic" id="id46">|Conv_1
Producer_2--&gt;|</span></a>”0 [4]&amp;rarr;2”<a href="#id47"><span class="problematic" id="id48">|Conv_0
Producer_1--&gt;|</span></a>”0 [4, 3, 3, 3]&amp;rarr;1”<a href="#id49"><span class="problematic" id="id50">|Conv_0
Producer_4--&gt;|</span></a>”0 [10, 7, 1, 1]&amp;rarr;1”<a href="#id51"><span class="problematic" id="id52">|Conv_2
Producer_5--&gt;|</span></a>”0 [10]&amp;rarr;2”<a href="#id53"><span class="problematic" id="id54">|Conv_2
Producer_0--&gt;|</span></a>”0 [2, 3, 13, 24]&amp;rarr;0”<a href="#id55"><span class="problematic" id="id56">|Conv_0
input0((in#0)):::inputCls---&gt;|</span></a>”&amp;rarr;2”<a href="#id57"><span class="problematic" id="id58">|Conv_1
Conv_2---&gt;|</span></a>”0 [2, 10, 5, 10]&amp;rarr;”<a href="#id5"><span class="problematic" id="id6">|</span></a>output0((out#0)):::outputCls
classDef inputCls fill:#afa
classDef outputCls fill:#ffa
classDef externalCls fill:#ccc
classDef producerCls fill:#ccf
classDef genericCls fill:#f9f9ff,stroke-width:1px,stroke-dasharray: 5 5
classDef metaCls stroke-width:5px
classDef rootCls stroke:#f00
classDef producerCls_rootCls stroke:#f00,fill:#ccf
classDef genericCls_rootCls stroke:#f00,fill:#f9f9ff,stroke-width:1px,stroke-dasharray: 5 5
classDef metaCls_rootCls stroke:#f00,stroke-width:5px</p>
<p><a href="#id7"><span class="problematic" id="id8">``</span></a><a href="#id9"><span class="problematic" id="id10">`</span></a></p>
<p>Output graph:</p>
<p><a href="#id11"><span class="problematic" id="id12">``</span></a><a href="#id13"><span class="problematic" id="id14">`</span></a>mermaid
%%{init: {‘flowchart’: { ‘curve’: ‘monotoneY’}, ‘fontFamily’: ‘Verdana’ } }%%
flowchart TB</p>
<p>Producer_0(“dataProvidern&lt;sub&gt;&lt;em&gt;(Producer#0)&lt;/em&gt;&lt;/sub&gt;”):::producerCls_rootCls
MatMul_2(“conv3_matmuln&lt;sub&gt;&lt;em&gt;(MatMul#2)&lt;/em&gt;&lt;/sub&gt;”)
Producer_7(“conv3_reshape_shape_prodn&lt;sub&gt;&lt;em&gt;(Producer#7)&lt;/em&gt;&lt;/sub&gt;”):::producerCls
Reshape_2(“conv3_reshapen&lt;sub&gt;&lt;em&gt;(Reshape#2)&lt;/em&gt;&lt;/sub&gt;”)
Add_1(“conv3_addn&lt;sub&gt;&lt;em&gt;(Add#1)&lt;/em&gt;&lt;/sub&gt;”)
Producer_8(“conv3_b_reshape_0n&lt;sub&gt;&lt;em&gt;(Producer#8)&lt;/em&gt;&lt;/sub&gt;”):::producerCls
Producer_1(“conv1_w_reshape_0n&lt;sub&gt;&lt;em&gt;(Producer#1)&lt;/em&gt;&lt;/sub&gt;”):::producerCls
Unfold_2(“conv3_unfoldn&lt;sub&gt;&lt;em&gt;(Unfold#2)&lt;/em&gt;&lt;/sub&gt;”)
Producer_3(“conv1_b_reshape_0n&lt;sub&gt;&lt;em&gt;(Producer#3)&lt;/em&gt;&lt;/sub&gt;”):::producerCls
Unfold_0(“conv1_unfoldn&lt;sub&gt;&lt;em&gt;(Unfold#0)&lt;/em&gt;&lt;/sub&gt;”)
MatMul_0(“conv1_matmuln&lt;sub&gt;&lt;em&gt;(MatMul#0)&lt;/em&gt;&lt;/sub&gt;”)
Producer_2(“conv1_reshape_shape_prodn&lt;sub&gt;&lt;em&gt;(Producer#2)&lt;/em&gt;&lt;/sub&gt;”):::producerCls
Reshape_0(“conv1_reshapen&lt;sub&gt;&lt;em&gt;(Reshape#0)&lt;/em&gt;&lt;/sub&gt;”)
Add_0(“conv1_addn&lt;sub&gt;&lt;em&gt;(Add#0)&lt;/em&gt;&lt;/sub&gt;”)
Unfold_1(“conv2_unfoldn&lt;sub&gt;&lt;em&gt;(Unfold#1)&lt;/em&gt;&lt;/sub&gt;”)
MatMul_1(“conv2_matmuln&lt;sub&gt;&lt;em&gt;(MatMul#1)&lt;/em&gt;&lt;/sub&gt;”)
Producer_5(“conv2_reshape_shape_prodn&lt;sub&gt;&lt;em&gt;(Producer#5)&lt;/em&gt;&lt;/sub&gt;”):::producerCls
Reshape_1(“conv2_reshapen&lt;sub&gt;&lt;em&gt;(Reshape#1)&lt;/em&gt;&lt;/sub&gt;”)
Producer_4(“conv2_w_reshape_0n&lt;sub&gt;&lt;em&gt;(Producer#4)&lt;/em&gt;&lt;/sub&gt;”):::producerCls
Producer_6(“conv3_w_reshape_0n&lt;sub&gt;&lt;em&gt;(Producer#6)&lt;/em&gt;&lt;/sub&gt;”):::producerCls
Producer_0–&gt;|”0 [2, 3, 13, 24]&amp;rarr;0”<a href="#id59"><span class="problematic" id="id60">|Unfold_0
MatMul_2--&gt;|</span></a>”0 [2, 10, 50]&amp;rarr;0”<a href="#id61"><span class="problematic" id="id62">|Reshape_2
Producer_7--&gt;|</span></a>”0 [4]&amp;rarr;1”<a href="#id63"><span class="problematic" id="id64">|Reshape_2
Reshape_2--&gt;|</span></a>”0 [2, 10, 5, 10]&amp;rarr;0”<a href="#id65"><span class="problematic" id="id66">|Add_1
Producer_8--&gt;|</span></a>”0 [1, 10, 1, 1]&amp;rarr;1”<a href="#id67"><span class="problematic" id="id68">|Add_1
Producer_1--&gt;|</span></a>”0 [4, 27]&amp;rarr;0”<a href="#id69"><span class="problematic" id="id70">|MatMul_0
Unfold_2--&gt;|</span></a>”0 [2, 7, 50]&amp;rarr;1”<a href="#id71"><span class="problematic" id="id72">|MatMul_2
Producer_3--&gt;|</span></a>”0 [1, 4, 1, 1]&amp;rarr;1”<a href="#id73"><span class="problematic" id="id74">|Add_0
Unfold_0--&gt;|</span></a>”0 [2, 27, 242]&amp;rarr;1”<a href="#id75"><span class="problematic" id="id76">|MatMul_0
MatMul_0--&gt;|</span></a>”0 [2, 4, 242]&amp;rarr;0”<a href="#id77"><span class="problematic" id="id78">|Reshape_0
Producer_2--&gt;|</span></a>”0 [4]&amp;rarr;1”<a href="#id79"><span class="problematic" id="id80">|Reshape_0
Reshape_0--&gt;|</span></a>”0 [2, 4, 11, 22]&amp;rarr;0”<a href="#id81"><span class="problematic" id="id82">|Add_0
Add_0--&gt;|</span></a>”0 [2, 4, 11, 22]&amp;rarr;0”<a href="#id83"><span class="problematic" id="id84">|Unfold_1
Unfold_1--&gt;|</span></a>”0 [2, 36, 180]&amp;rarr;1”<a href="#id85"><span class="problematic" id="id86">|MatMul_1
MatMul_1--&gt;|</span></a>”0 [2, 7, 180]&amp;rarr;0”<a href="#id87"><span class="problematic" id="id88">|Reshape_1
Producer_5--&gt;|</span></a>”0 [4]&amp;rarr;1”<a href="#id89"><span class="problematic" id="id90">|Reshape_1
Reshape_1--&gt;|</span></a>”0 [2, 7, 9, 20]&amp;rarr;0”<a href="#id91"><span class="problematic" id="id92">|Unfold_2
Producer_4--&gt;|</span></a>”0 [7, 36]&amp;rarr;0”<a href="#id93"><span class="problematic" id="id94">|MatMul_1
Producer_6--&gt;|</span></a>”0 [10, 7]&amp;rarr;0”<a href="#id95"><span class="problematic" id="id96">|MatMul_2
Add_1---&gt;|</span></a>”0 [2, 10, 5, 10]&amp;rarr;”<a href="#id15"><span class="problematic" id="id16">|</span></a>output0((out#0)):::outputCls
classDef inputCls fill:#afa
classDef outputCls fill:#ffa
classDef externalCls fill:#ccc
classDef producerCls fill:#ccf
classDef genericCls fill:#f9f9ff,stroke-width:1px,stroke-dasharray: 5 5
classDef metaCls stroke-width:5px
classDef rootCls stroke:#f00
classDef producerCls_rootCls stroke:#f00,fill:#ccf
classDef genericCls_rootCls stroke:#f00,fill:#f9f9ff,stroke-width:1px,stroke-dasharray: 5 5
classDef metaCls_rootCls stroke:#f00,stroke-width:5px
<a href="#id17"><span class="problematic" id="id18">``</span></a><a href="#id19"><span class="problematic" id="id20">`</span></a></p>
</section>
<section id="expand-meta-operators">
<h2><a class="toc-backref" href="#id140" role="doc-backlink">Expand meta operators</a><a class="headerlink" href="#expand-meta-operators" title="Link to this heading">#</a></h2>
<p>Expand meta operators, replacing them with their inner graph (flatten the graph).</p>
<div class="sd-tab-set docutils">
<input checked="checked" id="sd-tab-item-4" name="sd-tab-set-3" type="radio">
<label class="sd-tab-label" for="sd-tab-item-4">
Python</label><div class="sd-tab-content docutils">
<dl class="py function">
<dt class="sig sig-object py" id="aidge_core.expand_metaops">
<span class="sig-prename descclassname"><span class="pre">aidge_core.</span></span><span class="sig-name descname"><span class="pre">expand_metaops</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">graph_view</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><a class="reference internal" href="graph.html#aidge_core.GraphView" title="aidge_core.aidge_core.GraphView"><span class="pre">aidge_core.aidge_core.GraphView</span></a></span></em>, <em class="sig-param"><span class="n"><span class="pre">recursive</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">bool</span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">False</span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">None</span></span></span><a class="headerlink" href="#aidge_core.expand_metaops" title="Link to this definition">#</a></dt>
<dd><p>Flatten the graph by replacing the meta operators by their micro graph.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters<span class="colon">:</span></dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>graph_view</strong> (<a class="reference internal" href="graph.html#aidge_core.GraphView" title="aidge_core.GraphView"><code class="xref py py-class docutils literal notranslate"><span class="pre">aidge_core.GraphView</span></code></a>) – Graph view on which we want to apply the recipe</p></li>
<li><p><strong>recursive</strong> (<em>bool</em>) – If true, recursively replace meta operators until there is no more meta operator in the graph.</p></li>
</ul>
</dd>
</dl>
</dd></dl>

</div>
<input id="sd-tab-item-5" name="sd-tab-set-3" type="radio">
<label class="sd-tab-label" for="sd-tab-item-5">
C++</label><div class="sd-tab-content docutils">
<dl class="cpp function">
<dt class="sig sig-object cpp" id="_CPPv4N5Aidge13expandMetaOpsENSt10shared_ptrI9GraphViewEEb">
<span class="target" id="Recipes_8hpp_1a965d064883305f80d7e4d8304ee102e9"></span><span class="kt"><span class="pre">void</span></span><span class="w"> </span><span class="sig-prename descclassname"><span class="n"><span class="pre">Aidge</span></span><span class="p"><span class="pre">::</span></span></span><span class="sig-name descname"><span class="n"><span class="pre">expandMetaOps</span></span></span><span class="sig-paren">(</span><span class="n"><span class="pre">std</span></span><span class="p"><span class="pre">::</span></span><span class="n"><span class="pre">shared_ptr</span></span><span class="p"><span class="pre">&lt;</span></span><a class="reference internal" href="graph.html#_CPPv4N5Aidge9GraphViewE" title="Aidge::GraphView"><span class="n"><span class="pre">GraphView</span></span></a><span class="p"><span class="pre">&gt;</span></span><span class="w"> </span><span class="n sig-param"><span class="pre">graph</span></span>, <span class="kt"><span class="pre">bool</span></span><span class="w"> </span><span class="n sig-param"><span class="pre">recursive</span></span><span class="w"> </span><span class="p"><span class="pre">=</span></span><span class="w"> </span><span class="k"><span class="pre">false</span></span><span class="sig-paren">)</span><a class="headerlink" href="#_CPPv4N5Aidge13expandMetaOpsENSt10shared_ptrI9GraphViewEEb" title="Link to this definition">#</a><br /></dt>
<dd><p>Flatten the graph by replacing the meta operators by their micro graph. </p>
<dl class="field-list simple">
<dt class="field-odd">Parameters<span class="colon">:</span></dt>
<dd class="field-odd"><p><strong>recursive</strong> – If true, recursively replace meta operators until there is no more meta operator in the graph. </p>
</dd>
</dl>
</dd></dl>

</div>
</div>
</section>
<section id="explicit-cast-move">
<h2><a class="toc-backref" href="#id141" role="doc-backlink">Explicit Cast Move</a><a class="headerlink" href="#explicit-cast-move" title="Link to this heading">#</a></h2>
<p>Insert Cast and Move operators where needed (thus removing all implicit data type conversion and backend change data movement).</p>
<div class="sd-tab-set docutils">
<input checked="checked" id="sd-tab-item-6" name="sd-tab-set-4" type="radio">
<label class="sd-tab-label" for="sd-tab-item-6">
C++</label><div class="sd-tab-content docutils">
<dl class="cpp function">
<dt class="sig sig-object cpp" id="_CPPv4N5Aidge16explicitCastMoveENSt10shared_ptrI9GraphViewEE">
<span class="target" id="Recipes_8hpp_1a8fc43dd3b51e7a32ae1fa5cc71ce544b"></span><span class="kt"><span class="pre">void</span></span><span class="w"> </span><span class="sig-prename descclassname"><span class="n"><span class="pre">Aidge</span></span><span class="p"><span class="pre">::</span></span></span><span class="sig-name descname"><span class="n"><span class="pre">explicitCastMove</span></span></span><span class="sig-paren">(</span><span class="n"><span class="pre">std</span></span><span class="p"><span class="pre">::</span></span><span class="n"><span class="pre">shared_ptr</span></span><span class="p"><span class="pre">&lt;</span></span><a class="reference internal" href="graph.html#_CPPv4N5Aidge9GraphViewE" title="Aidge::GraphView"><span class="n"><span class="pre">GraphView</span></span></a><span class="p"><span class="pre">&gt;</span></span><span class="w"> </span><span class="n sig-param"><span class="pre">graphView</span></span><span class="sig-paren">)</span><a class="headerlink" href="#_CPPv4N5Aidge16explicitCastMoveENSt10shared_ptrI9GraphViewEE" title="Link to this definition">#</a><br /></dt>
<dd><p>Add Cast and Move operators where needed to ensure no conversion needs to be done at the <a class="reference internal" href="operator.html#classAidge_1_1Operator"><span class="std std-ref">Operator</span></a> level. </p>
</dd></dl>

</div>
</div>
</section>
<section id="explicit-transpose">
<h2><a class="toc-backref" href="#id142" role="doc-backlink">Explicit Transpose</a><a class="headerlink" href="#explicit-transpose" title="Link to this heading">#</a></h2>
<p>Insert Transpose operators where needed to ensure no transposition needs to be done at the Operator level (thus removing all implicit data format conversion).</p>
<div class="sd-tab-set docutils">
<input checked="checked" id="sd-tab-item-7" name="sd-tab-set-5" type="radio">
<label class="sd-tab-label" for="sd-tab-item-7">
C++</label><div class="sd-tab-content docutils">
<dl class="cpp function">
<dt class="sig sig-object cpp" id="_CPPv4N5Aidge17explicitTransposeENSt10shared_ptrI9GraphViewEE">
<span class="target" id="Recipes_8hpp_1a9c506dc2f3fc6f46f60aaa07dc0ad329"></span><span class="kt"><span class="pre">void</span></span><span class="w"> </span><span class="sig-prename descclassname"><span class="n"><span class="pre">Aidge</span></span><span class="p"><span class="pre">::</span></span></span><span class="sig-name descname"><span class="n"><span class="pre">explicitTranspose</span></span></span><span class="sig-paren">(</span><span class="n"><span class="pre">std</span></span><span class="p"><span class="pre">::</span></span><span class="n"><span class="pre">shared_ptr</span></span><span class="p"><span class="pre">&lt;</span></span><a class="reference internal" href="graph.html#_CPPv4N5Aidge9GraphViewE" title="Aidge::GraphView"><span class="n"><span class="pre">GraphView</span></span></a><span class="p"><span class="pre">&gt;</span></span><span class="w"> </span><span class="n sig-param"><span class="pre">graphView</span></span><span class="sig-paren">)</span><a class="headerlink" href="#_CPPv4N5Aidge17explicitTransposeENSt10shared_ptrI9GraphViewEE" title="Link to this definition">#</a><br /></dt>
<dd><p>Add Transpose operators where needed to ensure no transposition needs to be done at the <a class="reference internal" href="operator.html#classAidge_1_1Operator"><span class="std std-ref">Operator</span></a> level. </p>
</dd></dl>

</div>
</div>
</section>
<section id="fuse-batchnorm">
<h2><a class="toc-backref" href="#id143" role="doc-backlink">Fuse BatchNorm</a><a class="headerlink" href="#fuse-batchnorm" title="Link to this heading">#</a></h2>
<p>Fuse batch normalization with the preceding Conv or FC operator, if possible.</p>
<div class="sd-tab-set docutils">
<input checked="checked" id="sd-tab-item-8" name="sd-tab-set-6" type="radio">
<label class="sd-tab-label" for="sd-tab-item-8">
Python</label><div class="sd-tab-content docutils">
<dl class="py function">
<dt class="sig sig-object py" id="aidge_core.fuse_batchnorm">
<span class="sig-prename descclassname"><span class="pre">aidge_core.</span></span><span class="sig-name descname"><span class="pre">fuse_batchnorm</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">graph_view</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><a class="reference internal" href="graph.html#aidge_core.GraphView" title="aidge_core.aidge_core.GraphView"><span class="pre">aidge_core.aidge_core.GraphView</span></a></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">None</span></span></span><a class="headerlink" href="#aidge_core.fuse_batchnorm" title="Link to this definition">#</a></dt>
<dd><p>Recipe to remove a flatten operator.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters<span class="colon">:</span></dt>
<dd class="field-odd"><p><strong>graph_view</strong> (<a class="reference internal" href="graph.html#aidge_core.GraphView" title="aidge_core.GraphView"><code class="xref py py-class docutils literal notranslate"><span class="pre">aidge_core.GraphView</span></code></a>) – Graph view on which we want to apply the recipe</p>
</dd>
</dl>
</dd></dl>

</div>
<input id="sd-tab-item-9" name="sd-tab-set-6" type="radio">
<label class="sd-tab-label" for="sd-tab-item-9">
C++</label><div class="sd-tab-content docutils">
<dl class="cpp function">
<dt class="sig sig-object cpp" id="_CPPv4N5Aidge13fuseBatchNormENSt10shared_ptrI9GraphViewEE">
<span class="target" id="Recipes_8hpp_1a0b2601b987fa203ea699031fe1fce23c"></span><span class="kt"><span class="pre">void</span></span><span class="w"> </span><span class="sig-prename descclassname"><span class="n"><span class="pre">Aidge</span></span><span class="p"><span class="pre">::</span></span></span><span class="sig-name descname"><span class="n"><span class="pre">fuseBatchNorm</span></span></span><span class="sig-paren">(</span><span class="n"><span class="pre">std</span></span><span class="p"><span class="pre">::</span></span><span class="n"><span class="pre">shared_ptr</span></span><span class="p"><span class="pre">&lt;</span></span><a class="reference internal" href="graph.html#_CPPv4N5Aidge9GraphViewE" title="Aidge::GraphView"><span class="n"><span class="pre">GraphView</span></span></a><span class="p"><span class="pre">&gt;</span></span><span class="w"> </span><span class="n sig-param"><span class="pre">graphView</span></span><span class="sig-paren">)</span><a class="headerlink" href="#_CPPv4N5Aidge13fuseBatchNormENSt10shared_ptrI9GraphViewEE" title="Link to this definition">#</a><br /></dt>
<dd><p>Fuse :cpp:function:<code class="docutils literal notranslate"><span class="pre">Aidge::BatchNorm</span></code> with :cpp:function:<code class="docutils literal notranslate"><span class="pre">Aidge::Conv</span></code> or :cpp:function:<code class="docutils literal notranslate"><span class="pre">Aidge::FC</span></code> Nodes. Ref: <a class="reference external" href="https://nenadmarkus.com/p/fusing-batchnorm-and-conv/">https://nenadmarkus.com/p/fusing-batchnorm-and-conv/</a>. </p>
<dl class="field-list simple">
<dt class="field-odd">Parameters<span class="colon">:</span></dt>
<dd class="field-odd"><p><strong>graphView</strong> – Graph view to use graph matching on, in order to apply transformations. </p>
</dd>
</dl>
</dd></dl>

</div>
</div>
</section>
<section id="fuse-matmul-and-add-to-fc">
<h2><a class="toc-backref" href="#id144" role="doc-backlink">Fuse MatMul and Add to FC</a><a class="headerlink" href="#fuse-matmul-and-add-to-fc" title="Link to this heading">#</a></h2>
<p>Fuse MatMul optionnally followed by Add operator into a FC operator.</p>
<div class="sd-tab-set docutils">
<input checked="checked" id="sd-tab-item-10" name="sd-tab-set-7" type="radio">
<label class="sd-tab-label" for="sd-tab-item-10">
Python</label><div class="sd-tab-content docutils">
<dl class="py function">
<dt class="sig sig-object py" id="aidge_core.matmul_to_fc">
<span class="sig-prename descclassname"><span class="pre">aidge_core.</span></span><span class="sig-name descname"><span class="pre">matmul_to_fc</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">graph_view</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><a class="reference internal" href="graph.html#aidge_core.GraphView" title="aidge_core.aidge_core.GraphView"><span class="pre">aidge_core.aidge_core.GraphView</span></a></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">None</span></span></span><a class="headerlink" href="#aidge_core.matmul_to_fc" title="Link to this definition">#</a></dt>
<dd><p>Recipe to Fuse MatMul and Add operators into an <a class="reference internal" href="operator.html#aidge_core.FC" title="aidge_core.FC"><code class="xref py py-class docutils literal notranslate"><span class="pre">aidge_core.FC</span></code></a> operator.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters<span class="colon">:</span></dt>
<dd class="field-odd"><p><strong>graph_view</strong> (<a class="reference internal" href="graph.html#aidge_core.GraphView" title="aidge_core.GraphView"><code class="xref py py-class docutils literal notranslate"><span class="pre">aidge_core.GraphView</span></code></a>) – Graph view on which we want to apply the recipe</p>
</dd>
</dl>
</dd></dl>

</div>
<input id="sd-tab-item-11" name="sd-tab-set-7" type="radio">
<label class="sd-tab-label" for="sd-tab-item-11">
C++</label><div class="sd-tab-content docutils">
<div class="admonition warning">
<p class="admonition-title">Warning</p>
<p>doxygenfunction: Cannot find function “Aidge::fuseMulAdd” in doxygen xml output for project “aidge” from directory: xml/</p>
</div>
</div>
</div>
</section>
<section id="fuse-to-meta-operator">
<h2><a class="toc-backref" href="#id145" role="doc-backlink">Fuse to meta operator</a><a class="headerlink" href="#fuse-to-meta-operator" title="Link to this heading">#</a></h2>
<p>Fuse each sub-graph matching a query in a Meta Operator.</p>
<div class="sd-tab-set docutils">
<input checked="checked" id="sd-tab-item-12" name="sd-tab-set-8" type="radio">
<label class="sd-tab-label" for="sd-tab-item-12">
Python</label><div class="sd-tab-content docutils">
<dl class="py function">
<dt class="sig sig-object py" id="aidge_core.fuse_to_metaops">
<span class="sig-prename descclassname"><span class="pre">aidge_core.</span></span><span class="sig-name descname"><span class="pre">fuse_to_metaops</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="o"><span class="pre">*</span></span><span class="n"><span class="pre">args</span></span></em>, <em class="sig-param"><span class="o"><span class="pre">**</span></span><span class="n"><span class="pre">kwargs</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#aidge_core.fuse_to_metaops" title="Link to this definition">#</a></dt>
<dd><p>Overloaded function.</p>
<ol class="arabic">
<li><p>fuse_to_metaops(gm: aidge_core.aidge_core.SinglePassGraphMatching, query: str, type: str = ‘’) -&gt; int</p>
<blockquote>
<div><p>Fuse each sub-graph matching a query in a Meta Operator.</p>
<dl class="field-list simple">
<dt class="field-odd">param gm<span class="colon">:</span></dt>
<dd class="field-odd"><p>SinglePassGraphMatching containing the graph to manipulate</p>
</dd>
<dt class="field-even">type gm<span class="colon">:</span></dt>
<dd class="field-even"><p><a class="reference internal" href="graphMatching.html#aidge_core.SinglePassGraphMatching" title="aidge_core.SinglePassGraphMatching"><code class="xref py py-class docutils literal notranslate"><span class="pre">aidge_core.SinglePassGraphMatching</span></code></a></p>
</dd>
<dt class="field-odd">param query<span class="colon">:</span></dt>
<dd class="field-odd"><p>Sub-graph matching query</p>
</dd>
<dt class="field-even">type query<span class="colon">:</span></dt>
<dd class="field-even"><p>str</p>
</dd>
<dt class="field-odd">param type<span class="colon">:</span></dt>
<dd class="field-odd"><p>Type name of the resulting meta operators</p>
</dd>
<dt class="field-even">type type<span class="colon">:</span></dt>
<dd class="field-even"><p>str, optional</p>
</dd>
<dt class="field-odd">return<span class="colon">:</span></dt>
<dd class="field-odd"><p>Number of sub-graph actually fused in a Meta Operator.</p>
</dd>
<dt class="field-even">rtype<span class="colon">:</span></dt>
<dd class="field-even"><p>int</p>
</dd>
</dl>
</div></blockquote>
</li>
<li><p>fuse_to_metaops(graph_view: aidge_core.aidge_core.GraphView, query: str, type: str = ‘’) -&gt; int</p>
<blockquote>
<div><p>Fuse each sub-graph matching a query in a Meta Operator.</p>
<dl class="field-list simple">
<dt class="field-odd">param graph_view<span class="colon">:</span></dt>
<dd class="field-odd"><p>Graph view on which we want to apply the recipe</p>
</dd>
<dt class="field-even">type graph_view<span class="colon">:</span></dt>
<dd class="field-even"><p><a class="reference internal" href="graph.html#aidge_core.GraphView" title="aidge_core.GraphView"><code class="xref py py-class docutils literal notranslate"><span class="pre">aidge_core.GraphView</span></code></a></p>
</dd>
<dt class="field-odd">param query<span class="colon">:</span></dt>
<dd class="field-odd"><p>Sub-graph matching query</p>
</dd>
<dt class="field-even">type query<span class="colon">:</span></dt>
<dd class="field-even"><p>str</p>
</dd>
<dt class="field-odd">param type<span class="colon">:</span></dt>
<dd class="field-odd"><p>Type name of the resulting meta operators</p>
</dd>
<dt class="field-even">type type<span class="colon">:</span></dt>
<dd class="field-even"><p>str, optional</p>
</dd>
<dt class="field-odd">return<span class="colon">:</span></dt>
<dd class="field-odd"><p>Number of sub-graph actually fused in a Meta Operator.</p>
</dd>
<dt class="field-even">rtype<span class="colon">:</span></dt>
<dd class="field-even"><p>int</p>
</dd>
</dl>
</div></blockquote>
</li>
</ol>
</dd></dl>

</div>
<input id="sd-tab-item-13" name="sd-tab-set-8" type="radio">
<label class="sd-tab-label" for="sd-tab-item-13">
C++</label><div class="sd-tab-content docutils">
<div class="admonition warning">
<p class="admonition-title">Warning</p>
<p>doxygenfunction: Unable to resolve function “Aidge::fuseToMetaOps” with arguments None in doxygen xml output for project “aidge” from directory: xml/.
Potential matches:
</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="o">-</span> <span class="n">size_t</span> <span class="n">fuseToMetaOps</span><span class="p">(</span><span class="n">SinglePassGraphMatching</span> <span class="o">&amp;</span><span class="n">gm</span><span class="p">,</span> <span class="n">const</span> <span class="n">std</span><span class="p">::</span><span class="n">string</span> <span class="o">&amp;</span><span class="n">query</span><span class="p">,</span> <span class="n">const</span> <span class="n">std</span><span class="p">::</span><span class="n">string</span> <span class="o">&amp;</span><span class="nb">type</span> <span class="o">=</span> <span class="s2">&quot;&quot;</span><span class="p">)</span>
<span class="o">-</span> <span class="n">size_t</span> <span class="n">fuseToMetaOps</span><span class="p">(</span><span class="n">std</span><span class="p">::</span><span class="n">shared_ptr</span><span class="o">&lt;</span><span class="n">GraphView</span><span class="o">&gt;</span> <span class="n">graph</span><span class="p">,</span> <span class="n">const</span> <span class="n">std</span><span class="p">::</span><span class="n">string</span> <span class="o">&amp;</span><span class="n">query</span><span class="p">,</span> <span class="n">const</span> <span class="n">std</span><span class="p">::</span><span class="n">string</span> <span class="o">&amp;</span><span class="nb">type</span> <span class="o">=</span> <span class="s2">&quot;&quot;</span><span class="p">)</span>
</pre></div>
</div>
</div>
</div>
</div>
</section>
<section id="matmul-tiling">
<h2><a class="toc-backref" href="#id146" role="doc-backlink">MatMul tiling</a><a class="headerlink" href="#matmul-tiling" title="Link to this heading">#</a></h2>
<p>Tile any <code class="docutils literal notranslate"><span class="pre">MatMul</span></code> operator to several fixed size matrix multiplications.
For instance, for a MatMul of size 80x80 and a tiling of 16x16, this will tile
the MatMul operator to 25 (5 by 5) MatMul operators of size 16x16, with Slice
operators inserted at the inputs and Concat operators inserted at the outputs.</p>
<p>This is especially useful when matrix multiplication must be mapped to fixed
maximum size hardware TPU (Tensor Processing Unit) or MMA (Matrix Multiplication
Accelerator). This recipe can be combined with the <code class="docutils literal notranslate"><span class="pre">convToMatMul</span></code> recipe in
order to convert convolutions to matrix multiplication beforehand, and
<code class="docutils literal notranslate"><span class="pre">constantFolding</span></code> recipe to fold sliced constant tensors.</p>
<div class="sd-tab-set docutils">
<input checked="checked" id="sd-tab-item-14" name="sd-tab-set-9" type="radio">
<label class="sd-tab-label" for="sd-tab-item-14">
C++</label><div class="sd-tab-content docutils">
<dl class="cpp function">
<dt class="sig sig-object cpp" id="_CPPv4N5Aidge12matMulTilingE7NodePtrRKNSt6vectorI9DimSize_tEE">
<span class="target" id="Recipes_8hpp_1a1839d151afdbb6d4dce330ac7c6cca24"></span><span class="kt"><span class="pre">void</span></span><span class="w"> </span><span class="sig-prename descclassname"><span class="n"><span class="pre">Aidge</span></span><span class="p"><span class="pre">::</span></span></span><span class="sig-name descname"><span class="n"><span class="pre">matMulTiling</span></span></span><span class="sig-paren">(</span><span class="n"><span class="pre">NodePtr</span></span><span class="w"> </span><span class="n sig-param"><span class="pre">matMul</span></span>, <span class="k"><span class="pre">const</span></span><span class="w"> </span><span class="n"><span class="pre">std</span></span><span class="p"><span class="pre">::</span></span><span class="n"><span class="pre">vector</span></span><span class="p"><span class="pre">&lt;</span></span><span class="n"><span class="pre">DimSize_t</span></span><span class="p"><span class="pre">&gt;</span></span><span class="w"> </span><span class="p"><span class="pre">&amp;</span></span><span class="n sig-param"><span class="pre">maxDims</span></span><span class="sig-paren">)</span><a class="headerlink" href="#_CPPv4N5Aidge12matMulTilingE7NodePtrRKNSt6vectorI9DimSize_tEE" title="Link to this definition">#</a><br /></dt>
<dd><p>Tile any :cpp:function:<code class="docutils literal notranslate"><span class="pre">Aidge::MatMul</span></code> operator to several fixed size matrix multiplications. For instance, for a MatMul of size 80x80 and a tiling of 16x16, this will tile the MatMul operator to 25 (5 by 5) MatMul operators of size 16x16, with Slice operators inserted at the inputs and Concat operators inserted at the outputs. </p>
<p>This is especially useful when matrix multiplication must be mapped to fixed maximum size hardware TPU (<a class="reference internal" href="data.html#classAidge_1_1Tensor"><span class="std std-ref">Tensor</span></a> Processing Unit) or MMA (Matrix Multiplication Accelerator). This recipe can be combined with the :cpp:function:<code class="docutils literal notranslate"><span class="pre">Aidge::convToMatMul</span></code> recipe in order to convert convolutions to matrix multiplication beforehand, and :cpp:function:<code class="docutils literal notranslate"><span class="pre">Aidge::constantFolding</span></code> recipe to fold sliced constant tensors.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters<span class="colon">:</span></dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>matMul</strong> – MatMul operator to be tiled. </p></li>
<li><p><strong>maxDims</strong> – Maximum output dimensions of the tiled MatMul operators. </p></li>
</ul>
</dd>
</dl>
</dd></dl>

</div>
</div>
<p>Initial graph:</p>
<p><a href="#id21"><span class="problematic" id="id22">``</span></a><a href="#id23"><span class="problematic" id="id24">`</span></a>mermaid
%%{init: {‘flowchart’: { ‘curve’: ‘monotoneY’}, ‘fontFamily’: ‘Verdana’ } }%%
flowchart TB</p>
<p>MatMul_0(“matmul1&lt;br/&gt;&lt;sub&gt;&lt;em&gt;(MatMul#0)&lt;/em&gt;&lt;/sub&gt;”):::rootCls
Producer_1(“w1&lt;br/&gt;&lt;sub&gt;&lt;em&gt;(Producer#1)&lt;/em&gt;&lt;/sub&gt;”):::producerCls
Producer_0(“dataProvider&lt;br/&gt;&lt;sub&gt;&lt;em&gt;(Producer#0)&lt;/em&gt;&lt;/sub&gt;”):::producerCls
MatMul_0—&gt;|”0 [2, 3, 80, 80]&amp;rarr;”<a href="#id97"><span class="problematic" id="id98">|output0((out#0)):::outputCls
Producer_1--&gt;|</span></a>”0 [2, 3, 80, 80]&amp;rarr;1”<a href="#id99"><span class="problematic" id="id100">|MatMul_0
Producer_0--&gt;|</span></a>”0 [2, 3, 80, 80]&amp;rarr;0”<a href="#id25"><span class="problematic" id="id26">|</span></a>MatMul_0
classDef inputCls fill:#afa
classDef outputCls fill:#ffa
classDef externalCls fill:#ccc
classDef producerCls fill:#ccf
classDef genericCls fill:#f9f9ff,stroke-width:1px,stroke-dasharray: 5 5
classDef metaCls stroke-width:5px
classDef rootCls stroke:#f00
classDef producerCls_rootCls stroke:#f00,fill:#ccf
classDef genericCls_rootCls stroke:#f00,fill:#f9f9ff,stroke-width:1px,stroke-dasharray: 5 5
classDef metaCls_rootCls stroke:#f00,stroke-width:5px
<a href="#id27"><span class="problematic" id="id28">``</span></a><a href="#id29"><span class="problematic" id="id30">`</span></a></p>
<p>Graph generated by a single step of the <code class="docutils literal notranslate"><span class="pre">matMulTiling</span></code> recipe (after the very first matrix multiplication split):</p>
<p><a href="#id31"><span class="problematic" id="id32">``</span></a><a href="#id33"><span class="problematic" id="id34">`</span></a>mermaid
%%{init: {‘flowchart’: { ‘curve’: ‘monotoneY’}, ‘fontFamily’: ‘Verdana’ } }%%
flowchart TB</p>
<p>Producer_7(&lt;em&gt;Producer#7&lt;/em&gt;):::producerCls
MatMul_1(&lt;em&gt;MatMul#1&lt;/em&gt;)
Concat_0(&lt;em&gt;Concat#0&lt;/em&gt;)
Producer_1(&lt;em&gt;Producer#1&lt;/em&gt;):::producerCls
Producer_2(&lt;em&gt;Producer#2&lt;/em&gt;):::producerCls
Producer_3(&lt;em&gt;Producer#3&lt;/em&gt;):::producerCls
Producer_4(&lt;em&gt;Producer#4&lt;/em&gt;):::producerCls
Producer_5(&lt;em&gt;Producer#5&lt;/em&gt;):::producerCls
Producer_6(&lt;em&gt;Producer#6&lt;/em&gt;):::producerCls
Identity_0(&lt;em&gt;Identity#0&lt;/em&gt;):::rootCls
Slice_0(&lt;em&gt;Slice#0&lt;/em&gt;)
Producer_0(&lt;em&gt;Producer#0&lt;/em&gt;):::producerCls
MatMul_0(&lt;em&gt;MatMul#0&lt;/em&gt;)
Identity_1(&lt;em&gt;Identity#1&lt;/em&gt;)
Slice_1(&lt;em&gt;Slice#1&lt;/em&gt;)
Producer_7–&gt;|”0 [2]&amp;rarr;4”<a href="#id101"><span class="problematic" id="id102">|Slice_1
MatMul_1--&gt;|</span></a>”0 [2, 3, 64, 80]&amp;rarr;1”<a href="#id103"><span class="problematic" id="id104">|Concat_0
Producer_1--&gt;|</span></a>”0 [2]&amp;rarr;2”<a href="#id105"><span class="problematic" id="id106">|Slice_0
Producer_2--&gt;|</span></a>”0 [2]&amp;rarr;3”<a href="#id107"><span class="problematic" id="id108">|Slice_0
Producer_3--&gt;|</span></a>”0 [2]&amp;rarr;4”<a href="#id109"><span class="problematic" id="id110">|Slice_0
Producer_4--&gt;|</span></a>”0 [2]&amp;rarr;1”<a href="#id111"><span class="problematic" id="id112">|Slice_1
Producer_5--&gt;|</span></a>”0 [2]&amp;rarr;2”<a href="#id113"><span class="problematic" id="id114">|Slice_1
Producer_6--&gt;|</span></a>”0 [2]&amp;rarr;3”<a href="#id115"><span class="problematic" id="id116">|Slice_1
Identity_0--&gt;|</span></a>”0 [2, 3, 80, 80]&amp;rarr;0”<a href="#id117"><span class="problematic" id="id118">|Slice_0
Identity_0--&gt;|</span></a>”0 [2, 3, 80, 80]&amp;rarr;0”<a href="#id119"><span class="problematic" id="id120">|Slice_1
Slice_0--&gt;|</span></a>”0 [2, 3, 16, 80]&amp;rarr;0”<a href="#id121"><span class="problematic" id="id122">|MatMul_0
Producer_0--&gt;|</span></a>”0 [2]&amp;rarr;1”<a href="#id123"><span class="problematic" id="id124">|Slice_0
MatMul_0--&gt;|</span></a>”0 [2, 3, 16, 80]&amp;rarr;0”<a href="#id125"><span class="problematic" id="id126">|Concat_0
Identity_1--&gt;|</span></a>”0 [2, 3, 80, 80]&amp;rarr;1”<a href="#id127"><span class="problematic" id="id128">|MatMul_1
Identity_1--&gt;|</span></a>”0 [2, 3, 80, 80]&amp;rarr;1”<a href="#id129"><span class="problematic" id="id130">|MatMul_0
Slice_1--&gt;|</span></a>”0 [2, 3, 64, 80]&amp;rarr;0”<a href="#id131"><span class="problematic" id="id132">|MatMul_1
input0((in#0)):::inputCls---&gt;|</span></a>”&amp;rarr;0[2, 3, 80, 80]”<a href="#id133"><span class="problematic" id="id134">|Identity_0
input1((in#1)):::inputCls---&gt;|</span></a>”&amp;rarr;0[2, 3, 80, 80]”<a href="#id135"><span class="problematic" id="id136">|Identity_1
Concat_0---&gt;|</span></a>”0 [2, 3, 80, 80]&amp;rarr;”<a href="#id35"><span class="problematic" id="id36">|</span></a>output0((out#0)):::outputCls
classDef inputCls fill:#afa
classDef outputCls fill:#ffa
classDef externalCls fill:#ccc
classDef producerCls fill:#ccf
classDef genericCls fill:#f9f9ff,stroke-width:1px,stroke-dasharray: 5 5
classDef metaCls stroke-width:5px
classDef rootCls stroke:#f00
classDef producerCls_rootCls stroke:#f00,fill:#ccf
classDef genericCls_rootCls stroke:#f00,fill:#f9f9ff,stroke-width:1px,stroke-dasharray: 5 5
classDef metaCls_rootCls stroke:#f00,stroke-width:5px
<a href="#id37"><span class="problematic" id="id38">``</span></a><a href="#id39"><span class="problematic" id="id40">`</span></a></p>
</section>
<section id="remove-dropout">
<h2><a class="toc-backref" href="#id147" role="doc-backlink">Remove Dropout</a><a class="headerlink" href="#remove-dropout" title="Link to this heading">#</a></h2>
<p>Remove Dropout operators.</p>
<div class="sd-tab-set docutils">
<input checked="checked" id="sd-tab-item-15" name="sd-tab-set-10" type="radio">
<label class="sd-tab-label" for="sd-tab-item-15">
C++</label><div class="sd-tab-content docutils">
<dl class="cpp function">
<dt class="sig sig-object cpp" id="_CPPv4N5Aidge13removeDropoutENSt10shared_ptrI9GraphViewEE">
<span class="target" id="Recipes_8hpp_1af35b6314ecec06f314dd5d1b48d65f7c"></span><span class="n"><span class="pre">size_t</span></span><span class="w"> </span><span class="sig-prename descclassname"><span class="n"><span class="pre">Aidge</span></span><span class="p"><span class="pre">::</span></span></span><span class="sig-name descname"><span class="n"><span class="pre">removeDropout</span></span></span><span class="sig-paren">(</span><span class="n"><span class="pre">std</span></span><span class="p"><span class="pre">::</span></span><span class="n"><span class="pre">shared_ptr</span></span><span class="p"><span class="pre">&lt;</span></span><a class="reference internal" href="graph.html#_CPPv4N5Aidge9GraphViewE" title="Aidge::GraphView"><span class="n"><span class="pre">GraphView</span></span></a><span class="p"><span class="pre">&gt;</span></span><span class="w"> </span><span class="n sig-param"><span class="pre">graphView</span></span><span class="sig-paren">)</span><a class="headerlink" href="#_CPPv4N5Aidge13removeDropoutENSt10shared_ptrI9GraphViewEE" title="Link to this definition">#</a><br /></dt>
<dd><p>Remove <code class="docutils literal notranslate"><span class="pre">Dropout</span></code> <a class="reference internal" href="graph.html#classAidge_1_1Node"><span class="std std-ref">Node</span></a>. </p>
<dl class="field-list simple">
<dt class="field-odd">Parameters<span class="colon">:</span></dt>
<dd class="field-odd"><p><strong>graphView</strong> – Graph view to use graph matching on, in order to apply transfomrations. </p>
</dd>
<dt class="field-even">Returns<span class="colon">:</span></dt>
<dd class="field-even"><p>size_t Number of identity nodes removed </p>
</dd>
</dl>
</dd></dl>

</div>
</div>
</section>
<section id="remove-flatten">
<h2><a class="toc-backref" href="#id148" role="doc-backlink">Remove Flatten</a><a class="headerlink" href="#remove-flatten" title="Link to this heading">#</a></h2>
<p>Remove Flatten operators.</p>
<div class="sd-tab-set docutils">
<input checked="checked" id="sd-tab-item-16" name="sd-tab-set-11" type="radio">
<label class="sd-tab-label" for="sd-tab-item-16">
Python</label><div class="sd-tab-content docutils">
<dl class="py function">
<dt class="sig sig-object py" id="aidge_core.remove_flatten">
<span class="sig-prename descclassname"><span class="pre">aidge_core.</span></span><span class="sig-name descname"><span class="pre">remove_flatten</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">graph_view</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><a class="reference internal" href="graph.html#aidge_core.GraphView" title="aidge_core.aidge_core.GraphView"><span class="pre">aidge_core.aidge_core.GraphView</span></a></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">None</span></span></span><a class="headerlink" href="#aidge_core.remove_flatten" title="Link to this definition">#</a></dt>
<dd><p>Recipe to remove a Flatten operator if it is followed by a FC or a MatMul.
The recipe can remove multiple Flatten operator if they are one after the other.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters<span class="colon">:</span></dt>
<dd class="field-odd"><p><strong>graph_view</strong> (<a class="reference internal" href="graph.html#aidge_core.GraphView" title="aidge_core.GraphView"><code class="xref py py-class docutils literal notranslate"><span class="pre">aidge_core.GraphView</span></code></a>) – Graph view on which we want to apply the recipe.</p>
</dd>
</dl>
</dd></dl>

</div>
<input id="sd-tab-item-17" name="sd-tab-set-11" type="radio">
<label class="sd-tab-label" for="sd-tab-item-17">
C++</label><div class="sd-tab-content docutils">
<dl class="cpp function">
<dt class="sig sig-object cpp" id="_CPPv4N5Aidge13removeFlattenENSt10shared_ptrI9GraphViewEE">
<span class="target" id="Recipes_8hpp_1aecfc19999b83d4030f9c9f90a358eedf"></span><span class="kt"><span class="pre">void</span></span><span class="w"> </span><span class="sig-prename descclassname"><span class="n"><span class="pre">Aidge</span></span><span class="p"><span class="pre">::</span></span></span><span class="sig-name descname"><span class="n"><span class="pre">removeFlatten</span></span></span><span class="sig-paren">(</span><span class="n"><span class="pre">std</span></span><span class="p"><span class="pre">::</span></span><span class="n"><span class="pre">shared_ptr</span></span><span class="p"><span class="pre">&lt;</span></span><a class="reference internal" href="graph.html#_CPPv4N5Aidge9GraphViewE" title="Aidge::GraphView"><span class="n"><span class="pre">GraphView</span></span></a><span class="p"><span class="pre">&gt;</span></span><span class="w"> </span><span class="n sig-param"><span class="pre">graphView</span></span><span class="sig-paren">)</span><a class="headerlink" href="#_CPPv4N5Aidge13removeFlattenENSt10shared_ptrI9GraphViewEE" title="Link to this definition">#</a><br /></dt>
<dd><p>Remove <code class="docutils literal notranslate"><span class="pre">Flatten</span></code> before :cpp:function:<code class="docutils literal notranslate"><span class="pre">Aidge::FC</span></code> <a class="reference internal" href="graph.html#classAidge_1_1Node"><span class="std std-ref">Node</span></a>. </p>
<dl class="field-list simple">
<dt class="field-odd">Parameters<span class="colon">:</span></dt>
<dd class="field-odd"><p><strong>graphView</strong> – Graph view to use graph matching on, in order to apply transformations. </p>
</dd>
</dl>
</dd></dl>

</div>
</div>
</section>
</section>


                </article>
              
              
              
              
              
                <footer class="prev-next-footer d-print-none">
                  
<div class="prev-next-area">
    <a class="left-prev"
       href="graphMatching.html"
       title="previous page">
      <i class="fa-solid fa-angle-left"></i>
      <div class="prev-next-info">
        <p class="prev-next-subtitle">previous</p>
        <p class="prev-next-title">Graph Matching</p>
      </div>
    </a>
    <a class="right-next"
       href="export.html"
       title="next page">
      <div class="prev-next-info">
        <p class="prev-next-subtitle">next</p>
        <p class="prev-next-title">Export</p>
      </div>
      <i class="fa-solid fa-angle-right"></i>
    </a>
</div>
                </footer>
              
            </div>
            
            
              
                <dialog id="pst-secondary-sidebar-modal"></dialog>
                <div id="pst-secondary-sidebar" class="bd-sidebar-secondary bd-toc"><div class="sidebar-secondary-items sidebar-secondary__inner">


  <div class="sidebar-secondary-item">
<div
    id="pst-page-navigation-heading-2"
    class="page-toc tocsection onthispage">
    <i class="fa-solid fa-list"></i> On this page
  </div>
  <nav class="bd-toc-nav page-toc" aria-labelledby="pst-page-navigation-heading-2">
    <ul class="visible nav section-nav flex-column">
<li class="toc-h2 nav-item toc-entry"><a class="reference internal nav-link" href="#adapt-to-backend">Adapt to backend</a><ul class="visible nav section-nav flex-column">
<li class="toc-h3 nav-item toc-entry"><a class="reference internal nav-link" href="#aidge_core.adapt_to_backend"><code class="docutils literal notranslate"><span class="pre">adapt_to_backend()</span></code></a></li>
<li class="toc-h3 nav-item toc-entry"><a class="reference internal nav-link" href="#_CPPv4N5Aidge14adaptToBackendENSt10shared_ptrI9GraphViewEE"><code class="docutils literal notranslate"><span class="pre">adaptToBackend()</span></code></a></li>
</ul>
</li>
<li class="toc-h2 nav-item toc-entry"><a class="reference internal nav-link" href="#constant-folding">Constant folding</a><ul class="visible nav section-nav flex-column">
<li class="toc-h3 nav-item toc-entry"><a class="reference internal nav-link" href="#_CPPv4N5Aidge15constantFoldingENSt10shared_ptrI9GraphViewEE"><code class="docutils literal notranslate"><span class="pre">constantFolding()</span></code></a></li>
</ul>
</li>
<li class="toc-h2 nav-item toc-entry"><a class="reference internal nav-link" href="#convert-conv-to-matmul">Convert Conv to MatMul</a></li>
<li class="toc-h2 nav-item toc-entry"><a class="reference internal nav-link" href="#expand-meta-operators">Expand meta operators</a><ul class="visible nav section-nav flex-column">
<li class="toc-h3 nav-item toc-entry"><a class="reference internal nav-link" href="#aidge_core.expand_metaops"><code class="docutils literal notranslate"><span class="pre">expand_metaops()</span></code></a></li>
<li class="toc-h3 nav-item toc-entry"><a class="reference internal nav-link" href="#_CPPv4N5Aidge13expandMetaOpsENSt10shared_ptrI9GraphViewEEb"><code class="docutils literal notranslate"><span class="pre">expandMetaOps()</span></code></a></li>
</ul>
</li>
<li class="toc-h2 nav-item toc-entry"><a class="reference internal nav-link" href="#explicit-cast-move">Explicit Cast Move</a><ul class="visible nav section-nav flex-column">
<li class="toc-h3 nav-item toc-entry"><a class="reference internal nav-link" href="#_CPPv4N5Aidge16explicitCastMoveENSt10shared_ptrI9GraphViewEE"><code class="docutils literal notranslate"><span class="pre">explicitCastMove()</span></code></a></li>
</ul>
</li>
<li class="toc-h2 nav-item toc-entry"><a class="reference internal nav-link" href="#explicit-transpose">Explicit Transpose</a><ul class="visible nav section-nav flex-column">
<li class="toc-h3 nav-item toc-entry"><a class="reference internal nav-link" href="#_CPPv4N5Aidge17explicitTransposeENSt10shared_ptrI9GraphViewEE"><code class="docutils literal notranslate"><span class="pre">explicitTranspose()</span></code></a></li>
</ul>
</li>
<li class="toc-h2 nav-item toc-entry"><a class="reference internal nav-link" href="#fuse-batchnorm">Fuse BatchNorm</a><ul class="visible nav section-nav flex-column">
<li class="toc-h3 nav-item toc-entry"><a class="reference internal nav-link" href="#aidge_core.fuse_batchnorm"><code class="docutils literal notranslate"><span class="pre">fuse_batchnorm()</span></code></a></li>
<li class="toc-h3 nav-item toc-entry"><a class="reference internal nav-link" href="#_CPPv4N5Aidge13fuseBatchNormENSt10shared_ptrI9GraphViewEE"><code class="docutils literal notranslate"><span class="pre">fuseBatchNorm()</span></code></a></li>
</ul>
</li>
<li class="toc-h2 nav-item toc-entry"><a class="reference internal nav-link" href="#fuse-matmul-and-add-to-fc">Fuse MatMul and Add to FC</a><ul class="visible nav section-nav flex-column">
<li class="toc-h3 nav-item toc-entry"><a class="reference internal nav-link" href="#aidge_core.matmul_to_fc"><code class="docutils literal notranslate"><span class="pre">matmul_to_fc()</span></code></a></li>
</ul>
</li>
<li class="toc-h2 nav-item toc-entry"><a class="reference internal nav-link" href="#fuse-to-meta-operator">Fuse to meta operator</a><ul class="visible nav section-nav flex-column">
<li class="toc-h3 nav-item toc-entry"><a class="reference internal nav-link" href="#aidge_core.fuse_to_metaops"><code class="docutils literal notranslate"><span class="pre">fuse_to_metaops()</span></code></a></li>
</ul>
</li>
<li class="toc-h2 nav-item toc-entry"><a class="reference internal nav-link" href="#matmul-tiling">MatMul tiling</a><ul class="visible nav section-nav flex-column">
<li class="toc-h3 nav-item toc-entry"><a class="reference internal nav-link" href="#_CPPv4N5Aidge12matMulTilingE7NodePtrRKNSt6vectorI9DimSize_tEE"><code class="docutils literal notranslate"><span class="pre">matMulTiling()</span></code></a></li>
</ul>
</li>
<li class="toc-h2 nav-item toc-entry"><a class="reference internal nav-link" href="#remove-dropout">Remove Dropout</a><ul class="visible nav section-nav flex-column">
<li class="toc-h3 nav-item toc-entry"><a class="reference internal nav-link" href="#_CPPv4N5Aidge13removeDropoutENSt10shared_ptrI9GraphViewEE"><code class="docutils literal notranslate"><span class="pre">removeDropout()</span></code></a></li>
</ul>
</li>
<li class="toc-h2 nav-item toc-entry"><a class="reference internal nav-link" href="#remove-flatten">Remove Flatten</a><ul class="visible nav section-nav flex-column">
<li class="toc-h3 nav-item toc-entry"><a class="reference internal nav-link" href="#aidge_core.remove_flatten"><code class="docutils literal notranslate"><span class="pre">remove_flatten()</span></code></a></li>
<li class="toc-h3 nav-item toc-entry"><a class="reference internal nav-link" href="#_CPPv4N5Aidge13removeFlattenENSt10shared_ptrI9GraphViewEE"><code class="docutils literal notranslate"><span class="pre">removeFlatten()</span></code></a></li>
</ul>
</li>
</ul>
  </nav></div>

  <div class="sidebar-secondary-item">

  
  <div class="tocsection editthispage">
    <a href="https://gitlab.eclipse.org/eclipse/aidge/aidge/-/edit/master/docs/source/API/Core/recipes.rst">
      <i class="fa-solid fa-pencil"></i>
      
      
        
          Edit on GitLab
        
      
    </a>
  </div>
</div>

  <div class="sidebar-secondary-item">
  <div role="note" aria-label="source link">
    <h3>This Page</h3>
    <ul class="this-page-menu">
      <li><a href="../../../_sources/source/API/Core/recipes.rst.txt"
            rel="nofollow">Show Source</a></li>
    </ul>
   </div></div>

</div></div>
              
            
          </div>
          <footer class="bd-footer-content">
            
          </footer>
        
      </main>
    </div>
  </div>
  
  <!-- Scripts loaded after <body> so the DOM is not blocked -->
  <script defer src="../../../_static/scripts/bootstrap.js?digest=8878045cc6db502f8baf"></script>
<script defer src="../../../_static/scripts/pydata-sphinx-theme.js?digest=8878045cc6db502f8baf"></script>

  <footer class="bd-footer">
<div class="bd-footer__inner bd-page-width">
  
    <div class="footer-items__start">
      
        <div class="footer-item">

  <p class="copyright">
    
      © Copyright 2023, CEA LIST.
      <br/>
    
  </p>
</div>
      
        <div class="footer-item">

  <p class="sphinx-version">
    Created using <a href="https://www.sphinx-doc.org/">Sphinx</a> 8.1.3.
    <br/>
  </p>
</div>
      
    </div>
  
  
  
    <div class="footer-items__end">
      
        <div class="footer-item">
<p class="theme-version">
  <!-- # L10n: Setting the PST URL as an argument as this does not need to be localized -->
  Built with the <a href="https://pydata-sphinx-theme.readthedocs.io/en/stable/index.html">PyData Sphinx Theme</a> 0.16.1.
</p></div>
      
    </div>
  
</div>

  </footer>
  </body>
</html>